<?php
namespace Intergo\AuthClient;

use Intergo\BaseClient\Client;
use Intergo\BaseClient\Requests\AuthenticationRequest;
use Intergo\BaseClient\Requests\BaseRequest;
use Intergo\BaseClient\Responses\BaseResponseInterface;

class AuthClient extends Client
{
    /**
     * @return void
     */
    protected function setApiHandler()
    {
        $this->apiHandler = new AuthApiHandler();
    }

    /**
     * @param $endpoint
     * @param $urlParams
     * @param $bodyParams
     * @return BaseResponseInterface
     */
    public function execute($endpoint, $urlParams, $bodyParams)
    {
        $request = new BaseRequest($this->getUrl($endpoint, $urlParams), $this->traceId);
        return $this->process($request, $bodyParams, $endpoint);
    }

    /**
     * @param $endpoint
     * @param $bearerToken
     * @param $urlParams
     * @param $bodyParams
     * @return BaseResponseInterface
     */
    public function executeAuth($endpoint, $bearerToken, $urlParams, $bodyParams)
    {
        $request = new AuthenticationRequest($this->getUrl($endpoint, $urlParams), $bearerToken, $this->traceId);
        return $this->process($request, $bodyParams, $endpoint);
    }

    /**
     * @param $endpoint
     * @param $bodyParams
     * @return BaseResponseInterface
     */
    public function executeCustom($endpoint, $bodyParams)
    {
        $request = new BaseRequest($this->baseUrl . $endpoint, $this->traceId);
        return $this->process($request, $bodyParams, $endpoint);
    }
}
